## freeorion 0.4.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

include(GNUInstallDirs)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake ${CMAKE_HOME_DIRECTORY}/GG/cmake)
set(CMAKE_CONFIGURATION_TYPES Debug Release)
IF(NOT CMAKE_BUILD_TYPE)
  MESSAGE(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
ENDIF(NOT CMAKE_BUILD_TYPE)

message(STATUS "Build type CMAKE_BUILD_TYPE set to ${CMAKE_BUILD_TYPE}")

########################################
# Configuration                        #
########################################
project(FreeOrion)

set(FreeOrion_VERSION 0.4.6)

set(MINIMUM_BOOST_VERSION 1.54.0)
set(PYTHON_VERSION 2.7)

option(BUILD_TESTS "Controls generation of unit tests." OFF)

message(STATUS "Building tests BUILD_TESTS set to ${BUILD_TESTS}")
if (BUILD_TESTS)
  message( STATUS "Building Tests")
  enable_testing()
else()
  message( STATUS "Not building Tests")
endif ()

find_package (Threads)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

if(WIN32)
    set(CMAKE_INSTALL_BINDIR "")
    set(FreeOrion_INSTALL_LIBDIR "")
else()
    set(FreeOrion_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/freeorion")
endif()

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${FreeOrion_INSTALL_LIBDIR}")
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

if (WIN32)
    add_definitions(
        -D_CRT_SECURE_NO_DEPRECATE
        -D_SCL_SECURE_NO_DEPRECATE
        -D_CRT_NONSTDC_NO_DEPRECATE
        -DBOOST_ALL_DYN_LINK
        -DFREEORION_WIN32
        -D_WIN32_WINNT=0x0501
    )
    if (MSVC)
        set (CMAKE_PREFIX_PATH "${CMAKE_BINARY_DIR}/../")
        set (BOOST_ROOT "${CMAKE_BINARY_DIR}/../Boost")
        set (CMAKE_STATIC_LIBRARY_PREFIX "lib")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4099 /wd4101 /wd4146 /wd4244 /wd4251 /wd4258 /wd4267 /wd4275 /wd4351 /wd4800 /wd4996")
        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
        set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
    endif ()
elseif (APPLE)
    add_definitions(-DFREEORION_MACOSX)
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    add_definitions(
        -DFREEORION_LINUX
        -DENABLE_BINRELOC
        -DBOOST_ALL_DYN_LINK
    )
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wall -Wno-parentheses")
elseif (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    add_definitions(
        -DFREEORION_FREEBSD
        -DENABLE_BINRELOC
        -DBOOST_DATE_TIME_NO_LOCALE
    )
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wall -Wno-parentheses")
else ()
    message(FATAL_ERROR "Unknown platform type! Your setup is not a supported platform for FreeOrion.")
endif ()

# Need to know if the boost libraries are linked statically or dynamically
# If dynamically, add some macro definitions to prevent potential link errors
option(FO_LINK_STATIC_BOOST_LIBS "Link static boost libraries." OFF)

if (NOT FO_LINK_STATIC_BOOST_LIBS)
    add_definitions(
        -DBOOST_ALL_NO_LINK
        -DBOOST_ALL_DYN_LINK
        -DBOOST_LOG_DYN_LINK
    )
endif ()


find_package(PythonInterp ${PYTHON_VERSION} REQUIRED)

# To run the version generation every compile we need to deferr the
# execution to a separate target and the existing python command
add_custom_target(freeorionversion
    COMMAND
    "${PYTHON_EXECUTABLE}"
    "${CMAKE_SOURCE_DIR}/cmake/make_versioncpp.py"
    "${CMAKE_SOURCE_DIR}"
    "CMake"
)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/util/Version.cpp
    PROPERTIES
    GENERATED TRUE
)

if (WIN32)
    # Add icon resource file to freeorion.exe
    if (NOT EXISTS ${CMAKE_BINARY_DIR}/win32_resources.rc)
        file(WRITE ${CMAKE_BINARY_DIR}/win32_resources.rc "IDI_ICON ICON \"${CMAKE_SOURCE_DIR}/FreeOrion.ico\"")
    endif ()
endif ()

########################################
# Build common code library            #
########################################
set(BUILD_DEVEL_PACKAGE OFF CACHE INTERNAL "Disables installation of GiGi development files." FORCE)
set(_ORIG_CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
set(CMAKE_INSTALL_LIBDIR "${FreeOrion_INSTALL_LIBDIR}")
add_subdirectory(GG)
set(CMAKE_INSTALL_LIBDIR ${_ORIG_CMAKE_INSTALL_LIBDIR})
unset(_ORIG_CMAKE_INSTALL_LIBDIR)

########################################
# Dependencies                         #
########################################
find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS chrono date_time filesystem locale iostreams regex serialization signals system thread log REQUIRED)
find_package(ZLIB REQUIRED)
find_package(Freetype REQUIRED)

if(${Boost_VERSION} EQUAL "106100")
    # with boost 1.61 some boost::optional internals were changed. However
    # boost::spirit relies on some API the old implementation provided.  This
    # define enables the usage of the old boost::optional implementation.
    # boost upstream tracks this bug as #12349
    add_definitions(
        -DBOOST_OPTIONAL_CONFIG_USE_OLD_IMPLEMENTATION_OF_OPTIONAL
    )
endif()

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${FREETYPE_INCLUDE_DIRS}
    GG
)

link_directories(
    ${Boost_LIBRARY_DIRS}
)

set (freeorioncommon_HEADER
    combat/CombatEvent.h
    combat/CombatEvents.h
    combat/CombatLogManager.h
    combat/CombatSystem.h
    Empire/Diplomacy.h
    Empire/Empire.h
    Empire/EmpireManager.h
    Empire/ResourcePool.h
    Empire/Supply.h
    network/Message.h
    network/MessageQueue.h
    network/Networking.h
    python/SetWrapper.h
    python/CommonWrappers.h
    universe/Building.h
    universe/Condition.h
    universe/EffectAccounting.h
    universe/Effect.h
    universe/Encyclopedia.h
    universe/Enums.h
    universe/Field.h
    universe/Fighter.h
    universe/Fleet.h
    universe/Meter.h
    universe/ObjectMap.h
    universe/Planet.h
    universe/PopCenter.h
    universe/Predicates.h
    universe/ResourceCenter.h
    universe/ShipDesign.h
    universe/Ship.h
    universe/Special.h
    universe/Species.h
    universe/System.h
    universe/Tech.h
    universe/Universe.h
    universe/UniverseObject.h
    universe/TemporaryPtr.h
    universe/ValueRef.h
    universe/ValueRefFwd.h
    util/AppInterface.h
    util/blocking_combiner.h
    util/Directories.h
    util/EnumText.h
    util/i18n.h
    util/Logger.h
    util/ModeratorAction.h
    util/MultiplayerCommon.h
    util/OptionsDB.h
    util/OptionValidators.h
    util/Order.h
    util/OrderSet.h
    util/Process.h
    util/Random.h
    util/SaveGamePreviewUtils.h
    util/ScopedTimer.h
    util/Serialize.h
    util/Serialize.ipp
    util/SitRepEntry.h
    util/StringTable.h
    util/VarText.h
    util/Version.h
    util/XMLDoc.h
)

set (freeorioncommon_SOURCE
    combat/CombatEvent.cpp
    combat/CombatEvents.cpp
    combat/CombatLogManager.cpp
    Empire/Diplomacy.cpp
    Empire/Empire.cpp
    Empire/EmpireManager.cpp
    Empire/ResourcePool.cpp
    Empire/Supply.cpp
    network/Message.cpp
    network/MessageQueue.cpp
    network/Networking.cpp
    universe/Building.cpp
    universe/Condition.cpp
    universe/EffectAccounting.cpp
    universe/Effect.cpp
    universe/Encyclopedia.cpp
    universe/Enums.cpp
    universe/Field.cpp
    universe/Fighter.cpp
    universe/Fleet.cpp
    universe/Meter.cpp
    universe/ObjectMap.cpp
    universe/Planet.cpp
    universe/PopCenter.cpp
    universe/Predicates.cpp
    universe/ResourceCenter.cpp
    universe/Ship.cpp
    universe/ShipDesign.cpp
    universe/Special.cpp
    universe/Species.cpp
    universe/System.cpp
    universe/Tech.cpp
    universe/Universe.cpp
    universe/UniverseObject.cpp
    universe/ValueRef.cpp
    util/AppInterface.cpp
    util/DependencyVersions.cpp
    util/Directories.cpp
    util/EnumText.cpp
    util/i18n.cpp
    util/Logger.cpp
    util/ModeratorAction.cpp
    util/MultiplayerCommon.cpp
    util/OptionsDB.cpp
    util/Order.cpp
    util/OrderSet.cpp
    util/Process.cpp
    util/Random.cpp
    util/SaveGamePreviewUtils.cpp
    util/ScopedTimer.cpp
    util/SerializeEmpire.cpp
    util/SerializeModeratorAction.cpp
    util/SerializeMultiplayerCommon.cpp
    util/SerializeOrderSet.cpp
    util/SerializeUniverse.cpp
    util/SitRepEntry.cpp
    util/StringTable.cpp
    util/VarText.cpp
    util/Version.cpp
    util/XMLDoc.cpp
)

if (NOT WIN32)
    list(APPEND freeorioncommon_SOURCE
        util/binreloc.c
    )
endif ()

add_library(freeorioncommon
    ${freeorioncommon_HEADER}
    ${freeorioncommon_SOURCE}
)

add_dependencies(freeorioncommon freeorionversion)

if (CMAKE_CXX_COMPILER_ID STREQUAL Clang)
    set_property(
        SOURCE
        util/SerializePathingEngine.cpp
        PROPERTY
        COMPILE_FLAGS -ftemplate-depth=512
    )
endif ()

target_link_libraries(freeorioncommon
    ${Boost_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${OPENGL_LIBRARIES}
)

set_target_properties(freeorioncommon
    PROPERTIES
    DEFINE_SYMBOL "FREEORION_BUILD_COMMON"
)

if (CMAKE_COMPILER_IS_GNUCXX)
    set_target_properties(freeorioncommon
        PROPERTIES
        COMPILE_FLAGS "-fvisibility=hidden"
)
endif ()

########################################
# Recurse Into Sources                 #
########################################
add_subdirectory(parse)
add_subdirectory(server)
add_subdirectory(client/AI)
add_subdirectory(client/human)
add_subdirectory(doc)

########################################
# Packaging                            #
########################################
set(BUILD_PACKAGING
    false
    CACHE BOOL
    "Whether to build installer/binary package. (This is the executable installer on Win32, and an RPM/DEB/tarball on Linux."
)

install(
    DIRECTORY default/
    DESTINATION ${CMAKE_INSTALL_DATADIR}/freeorion/default
    COMPONENT COMPONENT_FREEORION_DATA
    PATTERN "*~" EXCLUDE
    PATTERN "*.pyc" EXCLUDE
)

install(
    TARGETS freeorioncommon
    LIBRARY DESTINATION ${FreeOrion_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT COMPONENT_FREEORION
)

install(
    FILES
    ${CMAKE_SOURCE_DIR}/freeorion.desktop
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications
    COMPONENT COMPONENT_FREEORION
)

foreach(SIZE 16 24 32 64 128 256)
    install(
        FILES
        ${CMAKE_SOURCE_DIR}/default/data/art/icons/FO_Icon_${SIZE}x${SIZE}.png
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/${SIZE}x${SIZE}/apps/
        RENAME freeorion.png
        COMPONENT COMPONENT_FREEORION
    )
endforeach()

if (WIN32)
    install(
        FILES
        OpenAL32.dll
        boost_date_time-vc90-mt-1_44.dll
        boost_filesystem-vc90-mt-1_44.dll
        boost_iostreams-vc90-mt-1_44.dll
        boost_python-vc90-mt-1_44.dll
        boost_regex-vc90-mt-1_44.dll
        boost_serialization-vc90-mt-1_44.dll
        boost_signals-vc90-mt-1_44.dll
        boost_system-vc90-mt-1_44.dll
        boost_thread-vc90-mt-1_44.dll
        glew32.dll
        jpeg.dll
        libexpat.dll
        libogg.dll
        libpng13.dll
        libvorbis.dll
        libvorbisfile.dll
        python26.dll
        wrap_oal.dll
        z.dll
        zlib1.dll
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT COMPONENT_FREEORION_WIN32_RUNTIME_DEPS
    )
endif ()

set(CPACK_PACKAGE_VERSION ${FreeOrion_VERSION})

set(CPACK_PACKAGE_VENDOR "FreeOrion Community")
set(CPACK_PACKAGE_CONTACT http://freeorion.org/forum)

=== GG/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

enable_testing()
include(CMakeDependentOption)
include(GNUInstallDirs)

project(GiGi)

########################################
# Configuration                        #
########################################
set(GIGI_VERSION 0.8.0)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake)

set(MINIMUM_BOOST_VERSION 1.47.0)

option(BUILD_SHARED_LIBS "Enables building of shared libraries; OFF implies static libraries." ON)

cmake_dependent_option(USE_STATIC_LIBS "Favour static linking of depencendies." OFF BUILD_SHARED_LIBS OFF)

if (BUILD_DEBUG)
    set(BUILD_RELEASE OFF)
else ()
    set(BUILD_RELEASE ON)
endif ()

if (DEFINED BUILD_STATIC OR DEFINED BUILD_SHARED)
    message(FATAL "BUILD_STATIC and BUILD_SHARED are removed in favour of BUILD_SHARED_LIBS.")
    return()
endif ()

include(Util)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

option(USE_DEVIL
       "Enables optional use of the DevIL image-loading library.  This should only be enabled if you need to load image files other than PNG, JPEG, and TIFF."
       OFF)

option(BUILD_SDL_DRIVER
       "Builds GG SDL support (the GiGiSDL library)."
       ON)
option(GiGi_BUILD_DOC
       "Builds HTML documentation (requires Doxygen)."
       OFF)
option(BUILD_DEVEL_PACKAGE
       "Install development files."
       ON)

if (NOT DEFINED USE_STATIC_LIBS)
    add_definitions(
        -DBOOST_ALL_NO_LINK
        -DBOOST_ALL_DYN_LINK
        -DBOOST_LOG_DYN_LINK
    )
endif ()

if (MSVC)
    set (CMAKE_STATIC_LIBRARY_PREFIX "lib")
    set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
    set (CMAKE_STATIC_LINKER_FLAGS "${CMAKE_STATIC_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
endif ()

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})


########################################
# Dependencies                         #
########################################
set(Boost_USE_STATIC_LIBS ${USE_STATIC_LIBS})
find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS chrono date_time filesystem regex signals system thread log REQUIRED)

include_directories(${Boost_INCLUDE_DIRS})

set(int_have_devil 0)
set(int_have_jpeg 0)
set(int_have_png 0)
set(int_have_tiff 0)
if (USE_DEVIL)
    find_package(DevIL REQUIRED)

    if (IL_FOUND)
        set(int_have_devil 1)
    endif ()

    include_directories(${IL_INCLUDE_DIR})
else ()
    find_package(JPEG)
    find_package(PNG)
    find_package(TIFF)

    if (JPEG_FOUND)
        include_directories(${JPEG_INCLUDE_DIR})
        set(int_have_jpeg 1)
    endif ()
    if (PNG_FOUND)
        include_directories(${PNG_INCLUDE_DIR})
        set(int_have_png 1)
    endif ()
    if (TIFF_FOUND)
        include_directories(${TIFF_INCLUDE_DIR})
        set(int_have_tiff 1)
    endif ()

endif ()

find_package(OpenGL REQUIRED)
find_package(Freetype REQUIRED)

if (NOT OPENGL_GLU_FOUND)
    message(FATAL_ERROR "OpenGL GLU library not found.")
endif ()

include_directories(
    ${OPENGL_INCLUDE_DIR}
    ${FREETYPE_INCLUDE_DIRS}
)

########################################
# Header Generation                    #
########################################
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/GG/Config.h
    @ONLY
)


########################################
# Installed Files                      #
########################################
if (BUILD_DEVEL_PACKAGE)
    install(
        DIRECTORY GG
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        COMPONENT COMPONENT_GIGI_DEVEL
    )
endif ()


########################################
# Recurse Into Sources                 #
########################################
add_subdirectory(src)

########################################
# Documentation                        #
########################################
if (GiGi_BUILD_DOC)
    find_package(Doxygen REQUIRED)
endif ()

if (DOXYGEN_FOUND)
    set(GG_DOC_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/doc")
    set(GG_DOC_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/doc")
    set(GG_DOC_STAMP_DIR "${GG_DOC_OUTPUT_DIR}/GG")
    configure_file(
        ${GG_DOC_SOURCE_DIR}/Doxyfile.in
        ${GG_DOC_OUTPUT_DIR}/Doxyfile
        @ONLY
        IMMEDIATE
    )

    if(NOT TARGET doc)
        add_custom_target(doc)
    endif()

    add_custom_command (
        OUTPUT ${GG_DOC_STAMP_DIR}/index.html
        COMMAND ${DOXYGEN_EXECUTABLE} ${GG_DOC_OUTPUT_DIR}/Doxyfile
        MAIN_DEPENDENCY ${GG_DOC_OUTPUT_DIR}/Doxyfile ${GG_DOC_SOURCE_DIR}/Doxyfile.in
        DEPENDS ${GG_DOC_SOURCE_DIR}/GGDoc.txt
        COMMENT "Generating GiGi API documentation with Doxygen" VERBATIM
    )
    add_custom_target (GiGi-apidoc DEPENDS ${GG_DOC_STAMP_DIR}/index.html)
    add_dependencies(doc GiGi-apidoc)

    if (BUILD_DEVEL_PACKAGE)
        install(
            DIRECTORY ${GG_DOC_STAMP_DIR}
            DESTINATION ${CMAKE_INSTALL_DOCDIR}
        )
    endif ()
endif ()


########################################
# Packaging                            #
########################################
set(CPACK_PACKAGE_VERSION ${GIGI_VERSION})
set(CPACK_PACKAGE_VENDOR "T. Zachary Laine")
set(CPACK_PACKAGE_CONTACT ${CPACK_PACKAGE_VENDOR})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A C++ OpenGL GUI library.")
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/COPYING)
set(CPACK_SYSTEM_NAME ${CMAKE_SYSTEM_NAME})
set(CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_SYSTEM_NAME}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-src)

# RPM-specific settings
set(CPACK_RPM_PACKAGE_LICENSE LGPL)
set(CPACK_RPM_PACKAGE_REQUIRES)

list(APPEND CPACK_RPM_PACKAGE_REQUIRES Mesa freetype2)
list(APPEND CPACK_RPM_PACKAGE_REQUIRES gigi=${GIGI_VERSION})

if (BUILD_SDL_DRIVER)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES SDL>=1.2)
endif ()

if (BUILD_DEVEL_PACKAGE)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES boost-devel>=1.44.0 Mesa-devel freetype2-devel)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES gigi-devel=${GIGI_VERSION})
endif ()

if (BUILD_DEVEL_PACKAGE AND BUILD_SDL_DRIVER)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES SDL-devel>=1.2)
endif ()

# Deb-specific settings
set(CPACK_DEBIAN_PACKAGE_SECTION libs)

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libgl1-mesa-glx | libgl1, libglu1-mesa | libglu, libfreetype6")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, gigi (= ${GIGI_VERSION})")

if (BUILD_SDL_DRIVER)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsdl1.2debian (>= 1.2)")
endif ()

if (BUILD_DEVEL_PACKAGE)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "boost-devel (>= 1.44.0), libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libfreetype6-dev")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, gigi-dev (= ${GIGI_VERSION})")
endif ()

if (BUILD_DEVEL_PACKAGE AND BUILD_SDL_DRIVER)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsdl1.2-dev (>= 1.2)")
endif ()

if (UNIX)
    set(CPACK_GENERATOR "TGZ;TBZ2")
    find_program(RPMBUILD rpmbuild)
    if (RPMBUILD)
        list(APPEND CPACK_GENERATOR RPM)
    endif ()
    set(RPMBUILD ${RPMBUILD} CACHE INTERNAL "")
    find_program(DPKG dpkg)
    if (DPKG)
        list(APPEND CPACK_GENERATOR DEB)
    endif ()
    set(DPKG ${DPKG} CACHE INTERNAL "")
    set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2")
elseif (WIN32)
    set(CPACK_GENERATOR "NSIS")
    set(CPACK_SOURCE_GENERATOR "ZIP")
endif ()

include(CPack)

cpack_add_component(
    COMPONENT_GIGI
    DISPLAY_NAME GiGi
    DESCRIPTION "The core GG library, including the GUI state machine and all the controls.  Not usable without an input driver."
    REQUIRED
    GROUP COMPONENT_GROUP_RUNTIME
)

cpack_add_component(
    COMPONENT_GIGISDL
    DISPLAY_NAME GiGiSDL
    DESCRIPTION "An SDL input driver (http://www.libsdl.org)."
    GROUP COMPONENT_GROUP_RUNTIME
    DEPENDS COMPONENT_GIGI
)

cpack_add_component(
    COMPONENT_GIGI_DEVEL
    DISPLAY_NAME "GiGi"
    DESCRIPTION "The files necessary to do development with GiGi."
    GROUP COMPONENT_GROUP_DEVEL
    DEPENDS COMPONENT_GIGI
)

cpack_add_component(
    COMPONENT_GIGISDL_DEVEL
    DISPLAY_NAME "GiGiSDL"
    DESCRIPTION "The files necessary to do development with GiGiSDL."
    GROUP COMPONENT_GROUP_DEVEL
    DEPENDS COMPONENT_GIGI_DEVEL COMPONENT_GIGISDL
)

cpack_add_component_group(
    COMPONENT_GROUP_RUNTIME
    DISPLAY_NAME "Runtime"
    DESCRIPTION "The runtime libs needed to run an application that uses GG."
    EXPANDED
)

cpack_add_component_group(
    COMPONENT_GROUP_DEVEL
    DISPLAY_NAME "Development"
    DESCRIPTION "The development libs and headers needed to build an application that uses GG."
    EXPANDED
)

=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

find_package(Doxygen)
# git allows shallow clones pushing only with version 1.9 or later
find_package(Git 1.9)

if(DOXYGEN_FOUND)
    set(FreeOrion_CPP_APIDOC_OUTDIR ${CMAKE_CURRENT_BINARY_DIR}/cpp-apidoc)

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
        ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        @ONLY
    )

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/apidoc-commit-message.in
        ${CMAKE_CURRENT_BINARY_DIR}/apidoc-commit-message
        @ONLY
    )

    if(NOT TARGET doc)
        add_custom_target(doc)
    endif()

    add_custom_target(cpp-apidoc
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${FreeOrion_SOURCE_DIR}
        COMMENT "Generating FreeOrion API documentation with Doxygen" VERBATIM
    )
    add_dependencies(doc cpp-apidoc)

    if(GIT_FOUND AND (DEFINED ENV{TRAVIS}))
        set(FreeOrion_APIDOC_GIT_REMOTE https://github.com/freeorion/freeorion.github.io.git)
        set(FreeOrion_APIDOC_GIT_LOCAL  ${CMAKE_CURRENT_BINARY_DIR}/apidoc-deploy.git)
        set(FreeOrion_CPP_APIDOC_PATH   cppapi/master)

        add_custom_target(apidoc-deploy
            COMMAND
                ${CMAKE_COMMAND} -E remove_directory ${FreeOrion_APIDOC_GIT_LOCAL}
            COMMAND
                ${CMAKE_COMMAND} -E make_directory ${FreeOrion_APIDOC_GIT_LOCAL}
            COMMAND
                ${CMAKE_COMMAND} -E chdir ${FreeOrion_APIDOC_GIT_LOCAL} ${GIT_EXECUTABLE} init
            COMMAND
                ${CMAKE_COMMAND} -E chdir ${FreeOrion_APIDOC_GIT_LOCAL} ${GIT_EXECUTABLE} pull --depth 1 ${FreeOrion_APIDOC_GIT_REMOTE} master:master
            COMMAND
                ${CMAKE_COMMAND} -E remove_directory ${FreeOrion_APIDOC_GIT_LOCAL}/${FreeOrion_CPP_APIDOC_PATH}
            COMMAND
                ${CMAKE_COMMAND} -E copy_directory ${FreeOrion_CPP_APIDOC_OUTDIR}/html ${FreeOrion_APIDOC_GIT_LOCAL}/${FreeOrion_CPP_APIDOC_PATH}
            COMMAND
                ${CMAKE_COMMAND} -E chdir ${FreeOrion_APIDOC_GIT_LOCAL} ${GIT_EXECUTABLE} add -A ${FreeOrion_CPP_APIDOC_PATH}
            COMMAND
                ${CMAKE_COMMAND} -E chdir ${FreeOrion_APIDOC_GIT_LOCAL} ${GIT_EXECUTABLE} commit -F ${CMAKE_CURRENT_SOURCE_DIR}/apidoc-commit-message
            COMMAND
                ${CMAKE_COMMAND} -E chdir ${FreeOrion_APIDOC_GIT_LOCAL} ${GIT_EXECUTABLE}  push ${FreeOrion_APIDOC_GIT_REMOTE} master:master
            DEPENDS cpp-apidoc freeorionversion
            COMMENT "Deploy FreeOrion API documentation to github.io" VERBATIM
        )
    endif()
endif()

=== parse/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

add_definitions(-DNDEBUG -DFREEORION_BUILD_PARSE)

if (NOT BUILD_TESTS)
    if (CMAKE_COMPILER_IS_GNUCXX)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -O3")
    endif ()
endif ()

set (freeorionparse_HEADER
    CommonParams.h
    ConditionParserImpl.h
    Double.h
    EffectParser.h
    EffectParserImpl.h
    EnumParser.h
    Int.h
    Label.h
    Lexer.h
    Parse.h
    ParseImpl.h
    ReportParseError.h
    Tokens.h
    ValueRefParser.h
    ValueRefParserImpl.h
)

set (freeorionparse_SOURCE
    AlignmentsParser.cpp
    BuildingsParser.cpp
    CommonParamsParser.cpp
    ConditionParser1.cpp
    ConditionParser2.cpp
    ConditionParser3.cpp
    ConditionParser4.cpp
    ConditionParser5.cpp
    ConditionParser6.cpp
    ConditionParser7.cpp
    ConditionParser.cpp
    Double.cpp
    DoubleComplexValueRefParser.cpp
    DoubleValueRefParser.cpp
    EffectParser1.cpp
    EffectParser2.cpp
    EffectParser3.cpp
    EffectParser4.cpp
    EffectParser5.cpp
    EffectParser.cpp
    EmpireStatsParser.cpp
    EncyclopediaParser.cpp
    EnumParser.cpp
    FieldsParser.cpp
    FleetPlansParser.cpp
    Int.cpp
    IntComplexValueRefParser.cpp
    IntValueRefParser.cpp
    ItemsParser.cpp
    KeymapParser.cpp
    Label.cpp
    Lexer.cpp
    MonsterFleetPlansParser.cpp
    Parse.cpp
    PlanetEnvironmentValueRefParser.cpp
    PlanetSizeValueRefParser.cpp
    PlanetTypeValueRefParser.cpp
    ReportParseError.cpp
    ShipDesignsParser.cpp
    ShipHullsParser.cpp
    ShipPartsParser.cpp
    SpecialsParser.cpp
    SpeciesParser.cpp
    StarTypeValueRefParser.cpp
    StringComplexValueRefParser.cpp
    StringValueRefParser.cpp
    TechsParser.cpp
    Tokens.cpp
    UniverseObjectTypeValueRefParser.cpp
    ValueRefParserImpl.cpp
)

add_library(freeorionparse
    ${freeorionparse_HEADER}
    ${freeorionparse_SOURCE}
)

if (CMAKE_CXX_COMPILER_ID STREQUAL Clang)
    set_property(
        SOURCE
        CommonParamsParser.cpp
        ConditionParser1.cpp
        EffectParser1.cpp
        EffectParser2.cpp
        PROPERTY
        COMPILE_FLAGS -ftemplate-depth=512
    )
endif ()

install(
    TARGETS freeorionparse
    LIBRARY DESTINATION ${FreeOrion_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT COMPONENT_FREEORION
)

=== server/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS iostreams python log REQUIRED)
find_package(PythonLibs ${PYTHON_VERSION} REQUIRED)

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_PATH}
)

add_definitions(-DFREEORION_BUILD_SERVER)

if (CMAKE_COMPILER_IS_GNUCXX)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
endif ()

set(freeoriond_LINK_LIBS
    freeorioncommon
    freeorionparse
    ${PYTHON_LIBRARIES}
    ${Boost_LIBRARIES}
)

if (WIN32)
    link_directories(${BOOST_LIBRARYDIR})
endif ()

set (freeoriond_HEADER
    ../network/ServerNetworking.h
    SaveLoad.h
    ServerApp.h
    ServerFSM.h
)

set (freeoriond_SOURCE
    dmain.cpp
    SaveLoad.cpp
    ServerApp.cpp
    ServerFSM.cpp
    ../combat/CombatSystem.cpp
    ../network/ServerNetworking.cpp
    ../python/CommonFramework.cpp
    ../python/EmpireWrapper.cpp
    ../python/EnumWrapper.cpp
    ../python/LoggingWrapper.cpp
    ../python/UniverseWrapper.cpp
    ../python/server/ServerWrapper.cpp
    ../python/server/ServerFramework.cpp
    ../universe/UniverseGenerator.cpp
)

add_executable(freeoriond
    ${freeoriond_HEADER}
    ${freeoriond_SOURCE}
)

target_link_libraries(freeoriond
    ${freeoriond_LINK_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
)

install(
    TARGETS freeoriond
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT COMPONENT_FREEORION
)

=== test/CMakeLists.txt ===
add_subdirectory(GG)
add_subdirectory(parse)

=== GG/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

message("-- Configuring GiGi")


set(GiGi_LINK_LIBS ${Boost_LIBRARIES} ${OPENGL_LIBRARIES} ${FREETYPE_LIBRARIES})
if (USE_DEVIL)
    list(APPEND GiGi_LINK_LIBS ${IL_LIBRARY} ${ILUT_LIBRARY})
else ()
    if (JPEG_FOUND)
        list(APPEND GiGi_LINK_LIBS ${JPEG_LIBRARIES})
    endif ()
    if (PNG_FOUND)
        list(APPEND GiGi_LINK_LIBS ${PNG_LIBRARIES})
    endif ()
    if (TIFF_FOUND)
        list(APPEND GiGi_LINK_LIBS ${TIFF_LIBRARIES})
    endif ()
endif ()

if (WIN32)
    if (MSVC)
        add_definitions(/wd4146 /wd4099 /wd4251 /wd4800 /wd4267 /wd4275
                        /wd4244 /wd4101 /wd4258 /wd4351 /wd4996)
    endif ()
endif ()

add_library(GiGi
    AlignmentFlags.cpp
    Base.cpp
    BrowseInfoWnd.cpp
    Button.cpp
    ClrConstants.cpp
    Control.cpp
    Cursor.cpp
    DrawUtil.cpp
    DropDownList.cpp
    DynamicGraphic.cpp
    Edit.cpp
    EventPump.cpp
    Font.cpp
    GLClientAndServerBuffer.cpp
    GroupBox.cpp
    GUI.cpp
    Layout.cpp
    ListBox.cpp
    Menu.cpp
    MultiEdit.cpp
    PtRect.cpp
    Scroll.cpp
    ScrollPanel.cpp
    StaticGraphic.cpp
    StyleFactory.cpp
    TabWnd.cpp
    TextControl.cpp
    Texture.cpp
    Timer.cpp
    UnicodeCharsets.cpp
    Wnd.cpp
    WndEvent.cpp
    ZList.cpp

    dialogs/ColorDlg.cpp
    dialogs/FileDlg.cpp
    dialogs/ThreeButtonDlg.cpp

    RichText/RichText.cpp
    RichText/TagParser.cpp
    RichText/ImageBlock.cpp
    RichText/TextBlock.cpp
    RichText/BlockControl.cpp
)

if (USE_STATIC_LIBS)
    set_target_properties(GiGi
        PROPERTIES
        LINK_SEARCH_END_STATIC true
    )
endif ()

target_link_libraries(GiGi ${GiGi_LINK_LIBS})

install(
    TARGETS GiGi
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT COMPONENT_GIGI
)

if (BUILD_DEVEL_PACKAGE)
    install(
        TARGETS GiGi
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT COMPONENT_GIGI_DEVEL
    )
endif ()

if (UNIX AND BUILD_DEVEL_PACKAGE)
    get_pkg_config_libs(pkg_config_libs ${GiGi_LINK_LIBS})

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/../cmake/GiGi.pc.in
        ${CMAKE_BINARY_DIR}/GiGi.pc
        @ONLY
    )

    install(
        FILES ${CMAKE_BINARY_DIR}/GiGi.pc
        DESTINATION  ${CMAKE_INSTALL_LIBDIR}/pkgconfig
        COMPONENT COMPONENT_GIGI_DEVEL
        OPTIONAL
    )
endif ()

if (BUILD_SDL_DRIVER)
    add_subdirectory(SDL)
endif ()

=== client/AI/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS python log REQUIRED)
find_package(PythonLibs ${PYTHON_VERSION} REQUIRED)

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_PATH}
)

add_definitions(-DFREEORION_BUILD_AI)

if (CMAKE_COMPILER_IS_GNUCXX)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
endif ()

set(freeorionca_LINK_LIBS
    freeorioncommon
    freeorionparse
    ${PYTHON_LIBRARIES}
    ${Boost_LIBRARIES}
)

if (WIN32)
    link_directories(${BOOST_LIBRARYDIR})
endif ()

set (freeorionca_HEADER
    AIClientApp.h
    ../ClientApp.h
    ../ClientFSMEvents.h
)

set (freeorionca_SOURCE
    ../../AI/AIInterface.cpp
    AIClientApp.cpp
    camain.cpp
    ../ClientApp.cpp
    ../ClientFSMEvents.cpp
    ../../combat/CombatSystem.cpp
    ../../network/ClientNetworking.cpp
    ../../python/CommonFramework.cpp
    ../../python/AI/AIFramework.cpp
    ../../python/EmpireWrapper.cpp
    ../../python/EnumWrapper.cpp
    ../../python/LoggingWrapper.cpp
    ../../python/UniverseWrapper.cpp
    ../../python/AI/AIWrapper.cpp
)

add_executable(freeorionca
    ${freeorionca_HEADER}
    ${freeorionca_SOURCE}
)

target_link_libraries(freeorionca
    ${freeorionca_LINK_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
)

install(
    TARGETS freeorionca
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT COMPONENT_FREEORION
)

=== client/human/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

find_package(OpenGL REQUIRED)
find_package(GLEW REQUIRED)

if (NOT OPENGL_GLU_FOUND)
    message(FATAL_ERROR "OpenGL GLU library not found.")
endif ()

find_package(SDL2 REQUIRED)
find_package(OpenAL REQUIRED)
find_package(Ogg REQUIRED)
find_package(Vorbis REQUIRED)

if(WIN32)
    find_package(GLEW REQUIRED)
endif()

include_directories(
    ${OPENGL_INCLUDE_DIR}
    ${GLEW_INCLUDE_DIRS}
    ${OPENAL_INCLUDE_DIR}
    ${SDL2_INCLUDE_DIR}
    ${OGG_INCLUDE_DIR}
    ${VORBIS_INCLUDE_DIR}

    ${CMAKE_SOURCE_DIR}/PagedGeometry/include
)

if(WIN32)
    include_directories(${GLEW_INCLUDE_DIRS})
endif()

add_definitions(-DFREEORION_BUILD_HUMAN)


if (CMAKE_COMPILER_IS_GNUCXX)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
endif ()

set(freeorion_HEADER
    ../ClientApp.h
    ../ClientFSMEvents.h
    HumanClientApp.cpp
    HumanClientApp.h
    ../../network/ClientNetworking.h
    ../../UI/About.h
    ../../UI/AccordionPanel.h
    ../../UI/BuildDesignatorWnd.h
    ../../UI/BuildingsPanel.h
    ../../UI/CensusBrowseWnd.h
    ../../UI/ChatWnd.h
    ../../UI/ClientUI.h
    ../../UI/CombatReport/GraphicalSummary.h
    ../../UI/CombatReport/CombatLogWnd.h
    ../../UI/CombatReport/CombatReportData.h
    ../../UI/CombatReport/CombatReportWnd.h
    ../../UI/CUIControls.h
    ../../UI/CUIDrawUtil.h
    ../../UI/CUISlider.h
    ../../UI/CUISpin.h
    ../../UI/CUIStyle.h
    ../../UI/CUIWnd.h
    ../../UI/DesignWnd.h
    ../../UI/EncyclopediaDetailPanel.h
    ../../UI/FieldIcon.h
    ../../UI/FleetButton.h
    ../../UI/FleetWnd.h
    ../../UI/GalaxySetupWnd.h
    ../../GG/GG/GLClientAndServerBuffer.h
    ../../UI/GraphControl.h
    ../../UI/Hotkeys.h
    ../../UI/IconTextBrowseWnd.h
    ../../UI/InGameMenu.h
    ../../UI/IntroScreen.h
    ../../UI/LinkText.h
    ../../UI/MapWnd.h
    ../../UI/MarkupBox.h
    ../../UI/MeterBrowseWnd.h
    ../../UI/MilitaryPanel.h
    ../../UI/ModeratorActionsWnd.h
    ../../UI/MultiIconValueIndicator.h
    ../../UI/MultiMeterStatusBar.h
    ../../UI/MultiplayerLobbyWnd.h
    ../../UI/ObjectListWnd.h
    ../../UI/OptionsWnd.h
    ../../UI/PlayerListWnd.h
    ../../UI/PopulationPanel.h
    ../../UI/ProductionWnd.h
    ../../UI/QueueListBox.h
    ../../UI/ResearchWnd.h
    ../../UI/ResourceBrowseWnd.h
    ../../UI/ResourcePanel.h
    ../../UI/SaveFileDialog.h
    ../../UI/ServerConnectWnd.h
    ../../UI/ShaderProgram.h
    ../../UI/ShipDesignPanel.h
    ../../UI/SidePanel.h
    ../../UI/SitRepPanel.h
    ../../UI/Sound.h
    ../../UI/SpecialsPanel.h
    ../../UI/SystemIcon.h
    ../../UI/SystemResourceSummaryBrowseWnd.h
    ../../UI/TechTreeArcs.h
    ../../UI/TechTreeLayout.h
    ../../UI/TechTreeWnd.h
    ../../UI/TextBrowseWnd.h
)

set(freeorion_SOURCES
    chmain.cpp
    ../ClientApp.cpp
    ../ClientFSMEvents.cpp
    HumanClientApp.cpp
    HumanClientFSM.cpp
    ../../combat/CombatSystem.cpp
    ../../network/ClientNetworking.cpp
    ../../UI/About.cpp
    ../../UI/AccordionPanel.cpp
    ../../UI/BuildDesignatorWnd.cpp
    ../../UI/BuildingsPanel.cpp
    ../../UI/CensusBrowseWnd.cpp
    ../../UI/ChatWnd.cpp
    ../../UI/ClientUI.cpp
    ../../UI/CombatReport/GraphicalSummary.cpp
    ../../UI/CombatReport/CombatLogWnd.cpp
    ../../UI/CombatReport/CombatReportData.cpp
    ../../UI/CombatReport/CombatReportWnd.cpp
    ../../UI/CUIControls.cpp
    ../../UI/CUIDrawUtil.cpp
    ../../UI/CUILinkTextBlock.cpp
    ../../UI/CUIStyle.cpp
    ../../UI/CUIWnd.cpp
    ../../UI/DesignWnd.cpp
    ../../UI/EncyclopediaDetailPanel.cpp
    ../../UI/FieldIcon.cpp
    ../../UI/FleetButton.cpp
    ../../UI/FleetWnd.cpp
    ../../UI/GalaxySetupWnd.cpp
    ../../GG/src/GLClientAndServerBuffer.cpp
    ../../UI/GraphControl.cpp
    ../../UI/Hotkeys.cpp
    ../../UI/IconTextBrowseWnd.cpp
    ../../UI/InGameMenu.cpp
    ../../UI/IntroScreen.cpp
    ../../UI/LinkText.cpp
    ../../UI/MapWnd.cpp
    ../../UI/MarkupBox.cpp
    ../../UI/MeterBrowseWnd.cpp
    ../../UI/MilitaryPanel.cpp
    ../../UI/ModeratorActionsWnd.cpp
    ../../UI/MultiIconValueIndicator.cpp
    ../../UI/MultiMeterStatusBar.cpp
    ../../UI/MultiplayerLobbyWnd.cpp
    ../../UI/ObjectListWnd.cpp
    ../../UI/OptionsWnd.cpp
    ../../UI/PlayerListWnd.cpp
    ../../UI/PopulationPanel.cpp
    ../../UI/ProductionWnd.cpp
    ../../UI/QueueListBox.cpp
    ../../UI/ResearchWnd.cpp
    ../../UI/ResourceBrowseWnd.cpp
    ../../UI/ResourcePanel.cpp
    ../../UI/SaveFileDialog.cpp
    ../../UI/ServerConnectWnd.cpp
    ../../UI/ShaderProgram.cpp
    ../../UI/ShipDesignPanel.cpp
    ../../UI/SidePanel.cpp
    ../../UI/SitRepPanel.cpp
    ../../UI/Sound.cpp
    ../../UI/SpecialsPanel.cpp
    ../../UI/SystemIcon.cpp
    ../../UI/SystemResourceSummaryBrowseWnd.cpp
    ../../UI/TechTreeArcs.cpp
    ../../UI/TechTreeLayout.cpp
    ../../UI/TechTreeWnd.cpp
    ../../UI/TextBrowseWnd.cpp
)

set(freeorion_LINK_LIBS
    freeorioncommon
    freeorionparse
    GiGi
    GiGiSDL
    ${OPENGL_gl_LIBRARY}
    ${OPENGL_glu_LIBRARY}
    ${GLEW_LIBRARIES}
    ${OPENAL_LIBRARY}
    ${Boost_LIBRARIES}
    ${SDL2_LIBRARY}
    ${OGG_LIBRARY}
    ${VORBIS_LIBRARIES}
    ${ZLIB_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
)

if (WIN32)
    link_directories(${BOOST_LIBRARYDIR})
    list(APPEND freeorion_SOURCES ${CMAKE_BINARY_DIR}/win32_resources.rc)
endif ()

add_executable(freeorion
    ${freeorion_HEADER}
    ${freeorion_SOURCES}
)

target_link_libraries(freeorion
    ${freeorion_LINK_LIBS}
)

install(
    TARGETS freeorion
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT COMPONENT_FREEORION
)

=== test/GG/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

message("-- Configuring GG Tests")

find_package(GLEW REQUIRED)
include_directories(
    ${OPENGL_INCLUDE_DIR}
)

# Include some useful utilities from the main code
set(freeorion_UTIL_SOURCES
    TestApp.cpp
    TestDialog.cpp
)

set(gg_test_LINK_LIBS
    GiGi
    GiGiSDL
    ${OPENGL_gl_LIBRARY}
    ${OPENGL_glu_LIBRARY}
    ${Boost_LIBRARIES}
    ${ZLIB_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
    ${GLEW_LIBRARIES}
)

if (WIN32)
    link_directories(${BOOST_LIBRARYDIR})
endif ()


macro (make_gigi_test name)
    add_executable(${name} ${ARGN} ${freeorion_UTIL_SOURCES})
    target_link_libraries(${name} ${gg_test_LINK_LIBS})
    set_target_properties(${name}
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ..
    )
endmacro ()

make_gigi_test(text_control TestTextControl.cpp)

=== test/parse/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

add_definitions(-DFREEORION_BUILD_SERVER)

add_executable(test_parsers
    test.cpp
    lexer_test_rules.cpp
)

target_link_libraries(test_parsers
    freeorioncommon
    freeorionparse
    log4cpp
    ${CMAKE_THREAD_LIBS_INIT}
)

find_package (Boost REQUIRED COMPONENTS unit_test_framework)

include_directories (
    ${Boost_UNIT_TEST_FRAMEWORK_INCLUDES}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
)

add_executable(test_parsers_boost
    testmain.cpp
    CommonTest.cpp
    TestEnumParser.cpp
    TestValueRefDoubleParser.cpp
    TestValueRefIntParser.cpp
    TestValueRefStringParser.cpp
    TestValueRefUniverseObjectTypeParser.cpp
)

target_link_libraries(test_parsers_boost
    freeorioncommon
    freeorionparse
    ${Boost_UNIT_TEST_FRAMEWORK_LIBRARIES}
)

add_test(enum_parser                           ${CMAKE_BINARY_DIR}/test_parsers_boost --run_test EnumParser)
add_test(value_ref_double_parser               ${CMAKE_BINARY_DIR}/test_parsers_boost --run_test ValueRefDoubleParser)
add_test(value_ref_int_parser                  ${CMAKE_BINARY_DIR}/test_parsers_boost --run_test ValueRefIntParser)
add_test(value_ref_string_parser               ${CMAKE_BINARY_DIR}/test_parsers_boost --run_test ValueRefStringParser)
add_test(value_ref_universe_object_type_parser ${CMAKE_BINARY_DIR}/test_parsers_boost --run_test ValueRefUniverseObjectTypeParser)

macro (add_test_and_data_files name)
    set(suffix "")
    set(args "")
    foreach (arg ${ARGN})
        if (EXISTS ${CMAKE_SOURCE_DIR}/parse/test/${arg})
            get_filename_component(filename_without_path ${arg} NAME)
            set(suffix ${suffix}-${filename_without_path})
            set(args "${args};${CMAKE_CURRENT_SOURCE_DIR}/${filename_without_path}")
        else ()
            set(suffix ${suffix}-${arg})
            set(args "${args};${arg}")
        endif ()
    endforeach ()
    add_test (${name}${suffix} ${CMAKE_BINARY_DIR}/${name} ${args})
endmacro ()

add_test_and_data_files(test_parsers lexer -f lexer_tokens)
add_test_and_data_files(test_parsers double_value_ref_parser -f double_variable)
add_test_and_data_files(test_parsers double_value_ref_parser -f double_variable_arithmetic)
add_test_and_data_files(test_parsers double_value_ref_parser -f double_statistic)
add_test_and_data_files(test_parsers string_value_ref_parser -f string_variable)
add_test_and_data_files(test_parsers string_value_ref_parser -f double_variable)
add_test_and_data_files(test_parsers string_value_ref_parser -f double_statistic)
add_test_and_data_files(test_parsers planet_size_value_ref_parser -f planet_size_constant)
add_test_and_data_files(test_parsers planet_size_value_ref_parser -f planet_size_variable)
add_test_and_data_files(test_parsers planet_size_value_ref_parser -f planet_size_statistic)
add_test_and_data_files(test_parsers planet_type_value_ref_parser -f planet_type_constant)
add_test_and_data_files(test_parsers planet_type_value_ref_parser -f planet_type_variable)
add_test_and_data_files(test_parsers planet_type_value_ref_parser -f planet_type_statistic)
add_test_and_data_files(test_parsers planet_environment_value_ref_parser -f planet_environment_constant)
add_test_and_data_files(test_parsers planet_environment_value_ref_parser -f planet_environment_variable)
add_test_and_data_files(test_parsers planet_environment_value_ref_parser -f planet_environment_statistic)
add_test_and_data_files(test_parsers star_type_value_ref_parser -f star_type_constant)
add_test_and_data_files(test_parsers star_type_value_ref_parser -f star_type_variable)
add_test_and_data_files(test_parsers star_type_value_ref_parser -f star_type_statistic)
add_test_and_data_files(test_parsers double_value_ref_evaluation -f double_arithmetic_evaluated)
add_test_and_data_files(test_parsers condition_parser -f condition_parser_1)
add_test_and_data_files(test_parsers condition_parser -f condition_parser_2)
add_test_and_data_files(test_parsers condition_parser -f condition_parser_3)
add_test_and_data_files(test_parsers effect_parser -f effect_parser)

add_test_and_data_files(test_parsers double_value_ref_parser -f double_arithmetic_errors --fail)
add_test_and_data_files(test_parsers double_value_ref_parser -f double_variable_errors --fail)
add_test_and_data_files(test_parsers double_value_ref_parser -f double_statistic_errors --fail)
add_test_and_data_files(test_parsers string_value_ref_parser -f string_variable_errors --fail)
add_test_and_data_files(test_parsers string_value_ref_parser -f string_statistic_errors --fail)
add_test_and_data_files(test_parsers planet_size_value_ref_parser -f planet_size_variable_errors --fail)
add_test_and_data_files(test_parsers planet_size_value_ref_parser -f planet_size_statistic_errors --fail)
add_test_and_data_files(test_parsers planet_type_value_ref_parser -f planet_type_variable_errors --fail)
add_test_and_data_files(test_parsers planet_type_value_ref_parser -f planet_type_statistic_errors --fail)
add_test_and_data_files(test_parsers planet_environment_value_ref_parser -f planet_environment_variable_errors --fail)
add_test_and_data_files(test_parsers planet_environment_value_ref_parser -f planet_environment_statistic_errors --fail)
add_test_and_data_files(test_parsers star_type_value_ref_parser -f star_type_variable_errors --fail)
add_test_and_data_files(test_parsers star_type_value_ref_parser -f star_type_statistic_errors --fail)
add_test_and_data_files(test_parsers condition_parser -f condition_parser_1_errors --fail)
add_test_and_data_files(test_parsers condition_parser -f condition_parser_2_errors --fail)
add_test_and_data_files(test_parsers condition_parser -f condition_parser_3_errors --fail)
add_test_and_data_files(test_parsers effect_parser -f effect_parser_errors --fail)

=== GG/src/SDL/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

project(GiGiSDL)
message("-- Configuring GiGiSDL")

set(SDL_BUILDING_LIBRARY true)

find_package(SDL2 REQUIRED)

include_directories(${SDL2_INCLUDE_DIR})

set(GiGiSDL_LINK_LIBS GiGi ${SDL2_LIBRARY})
add_library(GiGiSDL SDLGUI.cpp)

if (USE_STATIC_LIBS)
    set_target_properties(GiGiSDL
        PROPERTIES
        LINK_SEARCH_END_STATIC true
    )
endif ()

target_link_libraries(GiGiSDL ${GiGiSDL_LINK_LIBS})

install(
    TARGETS GiGiSDL
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT COMPONENT_GIGISDL
)

if (BUILD_DEVEL_PACKAGE)
    install(
        TARGETS GiGiSDL
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT COMPONENT_GIGISDL_DEVEL
    )
endif ()

if (UNIX AND BUILD_DEVEL_PACKAGE)
    get_pkg_config_libs(pkg_config_libs ${GiGiSDL_LINK_LIBS})

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake/GiGiSDL.pc.in
        ${CMAKE_BINARY_DIR}/GiGiSDL.pc
        @ONLY
    )

    install(
        FILES ${CMAKE_BINARY_DIR}/GiGiSDL.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
        COMPONENT COMPONENT_GIGI_DEVEL
        OPTIONAL
    )
endif ()

=== debian/changelog ===
freeorion (0.4.6-4) unstable; urgency=medium

  * Fix Lintian error and build-depend on dh-python.
  * Add mips64el to the list of supported architectures again.
    (Closes: #843538)

 -- Markus Koschany <apo@debian.org>  Thu, 05 Jan 2017 21:35:19 +0100

freeorion (0.4.6-3) unstable; urgency=medium

  * Apply boost1.62.patch to fix FTBFS with Boost 1.62.
    Thanks to Graham Inggs for the report and patch. (Closes: #843132)

 -- Markus Koschany <apo@debian.org>  Fri, 04 Nov 2016 17:26:01 +0100

freeorion (0.4.6-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * d/p/multiarch-fix.patch:
    - make the package multiarch ready, by fixing a wrong
      cmake inclusion order
  * d/{rules,freeorion.install} multiarchify. (Closes: #841824)

 -- Markus Koschany <apo@debian.org>  Sun, 23 Oct 2016 18:15:01 +0200

freeorion (0.4.6-1) unstable; urgency=medium

  * New upstream release.
  * Switch to compat level 10.
  * Update get-orig-source target.
  * Update freeorion.6 man page for latest release.
  * Remove source/local-options file.

 -- Markus Koschany <apo@debian.org>  Tue, 27 Sep 2016 15:04:12 +0200

freeorion (0.4.6~RC1-1) unstable; urgency=medium

  * New upstream release candidate.
  * Update get-orig-source target.
  * d/rules: Limit MaxParallel to 2 to avoid memory exhaustion on buildds.
  * Drop all patches. Fixed upstream.
  * freeorion-data: Depend on fonts-roboto-unhinted and use Debian's system
    fonts.
  * d/rules: Remove more extra license files to make Lintian happy.
  * d/copyright: Mention Apache-2.0 license of Roboto fonts.
  * Install CONTRIBUTING.md with freeorion-data.install file.

 -- Markus Koschany <apo@debian.org>  Mon, 12 Sep 2016 21:19:38 +0200

freeorion (0.4.5+git20160707-2) unstable; urgency=medium

  * Add boost1.61.patch and make-destructors-public.patch to work around a bug
    in Boost 1.61. (Closes: #833773)

 -- Markus Koschany <apo@debian.org>  Mon, 22 Aug 2016 01:39:06 +0200

freeorion (0.4.5+git20160707-1) unstable; urgency=medium

  * New upstream snapshot.
    - Fixes segfault on entry of dead_macron. (Closes: #825932)

 -- Markus Koschany <apo@debian.org>  Fri, 08 Jul 2016 23:24:12 +0200

freeorion (0.4.5+git20160501-1) unstable; urgency=medium

  * New upstream snapshot.
    - Game performance has improved. FreeOrion does not lag anymore.
      (Closes: #818524)
  * Install Changelog.md as upstream changelog.
  * Declare compliance with Debian Policy 3.9.8.
  * Vcs-fields: Use https.
  * Update my e-mail address.
  * debian/watch: Use version=4.

 -- Markus Koschany <apo@debian.org>  Mon, 02 May 2016 11:35:52 +0200

=== debian/control ===
Source: freeorion
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 10),
 dh-python,
 dpkg-dev (>= 1.17),
 libalut-dev,
 libboost-all-dev,
 libfreetype6-dev,
 libgl1-mesa-dev,
 libglew-dev,
 libglu1-mesa-dev,
 libjpeg-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libsdl2-dev,
 libtiff-dev,
 libvorbis-dev,
 pkg-config,
 python
Build-Depends-Indep:
 imagemagick
Standards-Version: 3.9.8
Homepage: http://www.freeorion.org
Vcs-Git: https://anonscm.debian.org/git/pkg-games/freeorion.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/freeorion.git

Package: freeorion
Architecture: alpha amd64 arm64 armel armhf hppa i386 mips64el powerpc ppc64 ppc64el s390x sparc64 x32
Depends:
 freeorion-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: turn-based space empire and galactic conquest game
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project. FreeOrion is inspired by the
 tradition of the Master of Orion games, but is not a clone or remake of that
 series or any other game.
 .
 The game is about the construction of a living, breathing universe in a grand
 campaign model. You can develop your own galactic empire and explore new star
 systems with your fleets as one of several unique human or alien species.
 Colonization of new worlds, researching new technology, managing your
 resources and defending your planets against the AI or other human players on
 a galactic scale are your main objectives.

Package: freeorion-data
Architecture: all
Depends:
 fonts-dejavu,
 fonts-roboto-unhinted,
 ${misc:Depends},
 ${python:Depends}
Suggests:
 freeorion
Description: turn-based space empire and galactic conquest game -- data
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project.
 .
 This package provides architecture-independent data files for FreeOrion,
 hundreds of unique designs for in-game icons, ships and planets, many
 different sounds and an immersive music score.
 .
 Also included are in-game descriptions, translations and game scripts.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
WEAK_HOSTS := armel armhf

ifneq (,$(findstring $(DEB_HOST_ARCH),$(WEAK_HOSTS)))
	MAX  := 1
	TYPE := MinSizeRel
else
	MAX  := 2
	TYPE := RelWithDebInfo
endif

%:
	dh $@ --max-parallel=$(MAX) --with python2

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_DOCUMENTATION=off \
		-DBUILD_TUTORIALS=off \
		-DLIB_SUFFIX=/freeorion \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_BUILD_TYPE=$(TYPE)

override_dh_auto_build-indep:
	## generate 32x32 xpm icon for compatibility reasons
	convert -monitor default/data/art/icons/FO_Icon_32x32.png debian/freeorion.xpm

#workaround for 'dpkg-shlibdeps: error: couldn't find library libGiGi*.so'
override_dh_shlibdeps:
	LD_LIBRARY_PATH="$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/freeorion:$(LD_LIBRARY_PATH)" dh_shlibdeps

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.md

override_dh_install:
	dh_install --fail-missing
	find debian -type d -empty -delete -printf 'removed %p\n'
	$(RM) -v debian/freeorion-data/usr/share/games/freeorion/default/LICENSE* \
		debian/freeorion-data/usr/share/games/freeorion/default/COPYING \
		debian/freeorion-data/usr/share/games/freeorion/default/data/fonts/LICENSE.*

override_dh_python2:
	dh_python2 -pfreeorion-data /usr/share/games

get-orig-source:
	wget https://github.com/freeorion/freeorion/releases/download/v0.4.6/FreeOrion_v0.4.6_2016-09-16.49f9123_Source.tar.gz
